// Author:		Dario Accornero <adario@cs.bu.edu>
// BeDev ID:	10183
// Project:		BeScript
// Module:
// Application object.

/*
	Copyright 2000, Dario Accornero.   All Rights Reserved.
	This file may be used under the terms of the Modified Be Sample Code License
	(the "Software License" document accompanying this file).
*/

#ifndef BESCRIPTAPP_H
#define BESCRIPTAPP_H

// System headers.

#ifndef _APPLICATION_H
#include <Application.h>
#endif

// Constants/macros.

#define BESCRIPT_APP_SIGNATURE	"application/x-vnd.bexoft-BeScript"
#define BESCRIPT_APP_RUNSCRIPT	'RunS'

// BeScript application.

class BeScriptApp : public BApplication
{
public:
	BeScriptApp(const char* signature = BESCRIPT_APP_SIGNATURE);
	virtual void ArgvReceived(int32 argc, char** argv);
	virtual void MessageReceived(BMessage* msg);
	virtual void ReadyToRun();

	static int globalVerbosity;
private:
	bool	fError;
	bool	fArgvReceived;
	bool	fPrintSyntax;
	bool	fExecute;
	
	void ProcessFiles(int32 argc, char** argv);
	void PrintUsage(const char* program);
};

#endif	//	BESCRIPTAPP_H
