//	Author:		Dario Accornero
//	BeDev ID:	10183
//	Mailto:		adario@cs.bu.edu
//	Project:	BeScript
//	Module:
//	The BeScriptPeek application.

/*
	Copyright 2000, Dario Accornero.   All Rights Reserved.
	This file may be used under the terms of the Modified Be Sample Code License
	(the "Software License" document accompanying this file).
*/

#ifndef	BESCRIPTPEEKAPP_H
#define	BESCRIPTPEEKAPP_H

//	System headers.

#ifndef _APPLICATION_H
#include <Application.h>
#endif

//	Constants/macros.

#define	BESCRIPTPEEK_APP_SIGNATURE		"application/x-vnd.bexoft-BeScriptPeek"
#define BESCRIPTPEEK_ADD_APPLICATION	'Aapp'
#define BESCRIPTPEEK_REMOVE_APPLICATION	'Rapp'
#define BESCRIPTPEEK_WATCH_LAUNCH		'WLau'
#define BESCRIPTPEEK_WATCH_QUIT			'WQui'
#define BESCRIPTPEEK_GET_DYNAMIC		'GDyn'
#define BESCRIPTPEEK_SYS_DEHYDRATE		'SDhy'
#define BESCRIPTPEEK_FULL_DEHYDRATE		'FDhy'
#define BESCRIPTPEEK_HIER_DEHYDRATE		'HDhy'
#define BESCRIPTPEEK_INVOKE_TARGET		'IvkT'
#define BESCRIPTPEEK_SELECT_TARGET		'SelT'

namespace BeScriptPeek {
	const float defaultWindowWidth = 550;
	const float defaultWindowHeight = 300;
};

//	Referenced/defined classes.

class BeScriptPeekApp;
class BeScriptPeekWindow;
class BMenuBar;

//	CLASSES:
//	The application. Display a window with a hierarchy of selected
//	(or all) scriptable objects currently running.

class BeScriptPeekApp : public BApplication
{
public:
	BeScriptPeekApp(const char* signature);
	virtual	void ArgvReceived(int32 argc, char** argv);
	virtual void ReadyToRun();
	virtual void AboutRequested();
	virtual void MessageReceived(BMessage* msg);
	virtual bool QuitRequested();

private:
	bool				fArgumentsReceived;
	BeScriptPeekWindow*	fWindow;

	void CreateAppWindow();
};

#endif	//	BESCRIPTPEEKAPP_H
