// Author:		Dario Accornero <adario@cs.bu.edu>
// BeDev ID:	10183
// Project:		BeScript
// Module:
// Scripting utilities.

/*
	Copyright 2000, Dario Accornero.   All Rights Reserved.
	This file may be used under the terms of the Modified Be Sample Code License
	(the "Software License" document accompanying this file).
*/

#ifndef	SCRIPTINGUTILS_H
#define	SCRIPTINGUTILS_H

//	System headers.

#ifndef __STRING__
#include <string>
#endif
#ifndef _MESSENGER_H
#include <Messenger.h>
#endif
#ifndef _BE_LIST_H
#include <List.h>
#endif
#ifndef _FONT_H
#include <Font.h>
#endif
#ifndef _PROPERTY_INFO_H
#include <PropertyInfo.h>
#endif

//	Referenced classes.

class BOutlineListView;

//	UTILITIES:

_EXPORT void print_message(BMessage* message);
_EXPORT void add_message_contents(BList* textlist, BMessage* msg, int32 level);
_EXPORT char* get_datatype_string(int32 type);
_EXPORT char* format_data(int32 type, char* ptr, long size);
_EXPORT bool is_valid_char(uint8 c);
_EXPORT char* id2str(int32 id, char* ptr);
_EXPORT string specifier_to_str(const BMessage* msg, bool skipFirst = false);
_EXPORT string data_to_str(const BMessage* msg);
_EXPORT bool FindFont(const char* fName, const char* fStyle, font_family* family, font_style* style);
_EXPORT void DehydratePropertyInfo(	BList* list,
									const BPropertyInfo& propinfo,
									int32 size,
									bool disable = true);
_EXPORT void FullDehydratePropertyInfo(	BList* list,
										const BPropertyInfo& propinfo,
										int32 size,
										bool disable = true);
#ifndef BESCRIPT
_EXPORT void InitRecursiveDehydration();
_EXPORT int32 RecursiveDehydratePropertyInfo(BMessenger* msgr,
											BMessage* access,
											BOutlineListView* list,
											const BMessage* suites,
											int level = 0);
#endif

#endif	//	SCRIPTINGUTILS_H
