// Author: Dario Accornero <adario@cs.bu.edu>
// BeDev ID: 10183
// Project: BeScript
// Module:
// Error handling.

/*
	Copyright 2000, Dario Accornero.   All Rights Reserved.
	This file may be used under the terms of the Modified Be Sample Code License
	(the "Software License" document accompanying this file).
*/

// Avoid multiple inclusion.

#ifndef ERRORMSG_H
#define ERRORMSG_H

// EXTERNAL EXPORTED DATA:
// Tracking position and error for lexical analysis.

extern bool	anyErrors;
extern int	EM_tokPos;

// Error handling routines.

void EM_newline(void);
void EM_error(int, const char*, ...);
void EM_debugError(int, const char*, int, const char*, ...);
void EM_open(const char*);
void EM_reset(void);
void EM_close(void);

#endif
